package com.keyboard.skinning.cool

//import com.pretty.keyboard.theme.keyboard.helper.ObjectBox
import android.app.Application
import android.graphics.Typeface
import com.anythink.core.api.ATSDK
import com.anythink.core.api.NetTrafficeCallback
import com.keyboard.skinning.cool.ad.AdManager
import com.keyboard.skinning.cool.data.ChildData
import com.keyboard.skinning.cool.data.ClassData
import org.json.JSONArray
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.io.StringWriter

class App : Application() {
    companion object {
        lateinit var appInstance: App

        lateinit var list: MutableList<ClassData>

        const val TAG = "-----------------"
        var defaultFont: Typeface? = null
        const val DB_VERSION = 1
        const val DB_NAME = "db_name"
    }

    override fun onCreate() {
        super.onCreate()
        appInstance = this
        initAd()
        defaultFont = Typeface.createFromAsset(assets, "my_font.ttf")
        dealFile()


    }

    private fun dealFile() {
        val openFile = appInstance.assets.open("res.json")
        val jsonString = getJsonString(openFile)
        if (jsonString != null) {
            resolveJsonString(jsonString)
        }
    }


    private fun resolveJsonString(string: String) {
        val jsonData = JSONArray(string)
        var dataList: MutableList<ClassData> = mutableListOf()
        for (i in 0 until jsonData.length()) {
            jsonData.getJSONObject(i).run {
                val pName = getString("parent_name")
                val listArray = getJSONArray("keyboard_list")
                var childDataList: MutableList<ChildData> = mutableListOf()
                for (listIndex in 0 until listArray.length()) {
                    listArray.getJSONObject(listIndex).also {
                        val title = it.getString("title")
                        val thUrl = it.getString("thumbUrl")
                        val thGif = it.getString("thumbUrlGif")
                        var zipPath = ""
                        var imgPath = ""
                        var imgGif = ""
                        var imgPreviewGif = ""
                        if (it.has("detail")) {
                            val contentObject =
                                it.getJSONObject("detail").getJSONObject("themeContent")
                            zipPath = contentObject.getString("androidRawZipUrl")
                            imgPath = contentObject.getString("img")
                            imgGif = contentObject.getString("imgGif")
                            imgPreviewGif = contentObject.getString("imgPreviewGif")
                        } else {

                        }
                        childDataList.add(
                            ChildData().apply {
                                setImgPath(imgPath)
                                setZipPath(zipPath)
                                setTitleName(title)
                                setImgGif(imgGif)
                                thumbUrl = thUrl
                                thumbGif = thGif
                            })

                    }

                }
                val shuffled = childDataList.shuffled()
                val dataClassData = ClassData()
                    .apply {
                        parentName = pName
                        keyboardList = shuffled
                    }
                dataList.add(dataClassData)

            }
        }

        updateDataList(dataList)

    }

    private fun updateDataList(mainList: MutableList<ClassData>) {
        list = mainList

    }

    private fun getJsonString(fileInputStream: InputStream): String? {
        return try {
            //            FileInputStream fileInputStream = new FileInputStream(path);
            val charArray = CharArray(fileInputStream.available())
            var readCount = 0
            val streamReader = InputStreamReader(fileInputStream)
            val bufferedReader = BufferedReader(streamReader)
            val stringWriter = StringWriter()
            while (bufferedReader.read(charArray).also { readCount = it } != -1) {
                stringWriter.write(charArray, 0, readCount)
            }
            stringWriter.toString()
        } catch (e: IOException) {
            ""
        }
    }


    private fun initAd() {
        ATSDK.checkIsEuTraffic(this, object : NetTrafficeCallback {
            override fun onResultCallback(isEU: Boolean) {

                if (isEU && ATSDK.getGDPRDataLevel(this@App) == ATSDK.UNKNOWN) {
                    ATSDK.showGdprAuth(this@App)
                }
            }

            override fun onErrorCallback(errorMsg: String) {

            }
        })
        val APPId = "h67db7f232075e"
        val AppKey = "ad87edbfa080f02492716cd8e4499fa07"
        ATSDK.init(this, APPId, AppKey)
        //测试工具
//        ATDebuggerUITest.showDebuggerUI(this,"8bd923b5b856161effd29abe2f86cc2cedcfd219")
        AdManager.loadAllAd()
    }


}